## metview 5.2.1

=== scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    generate_video
    mv_compress mv_mail mv_uniquename
    mv_eccharts.py
    mv_odbsql mv_obstat
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run mv_flexpart_pp
    mv_met3d_prep.mv
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh metgram.py)
endif()

if(HAVE_PPROC_MIR)
    list(APPEND scripts MarsMirWrapper DivrotMirWrapper)
endif()



# handle these script files
metview_script_files(SCRIPT_FILES ${scripts})



# remove unnecessary items from a colon-separated list (e.g. /usr/lib64, which can interfere if we use non-default compilers)
function(removeUnwantedCompileItemsFromColonString colonString)
    string (REPLACE ":"  ";"   LOC_AS_LIST "${${colonString}}")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib64")
    string (REPLACE ";"  ":"   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${colonString} ${LOC_AS_STRING} PARENT_SCOPE)
endfunction()


# remove non-compiler items and unnecessary items from the string
function(removeUnwantedCompileItems compileList)
    set(loc ${${compileList}})
    list(REMOVE_ITEM loc "debug")        
    list(REMOVE_ITEM loc "optimized")
    list(REMOVE_ITEM loc "/usr/lib")
    list(REMOVE_ITEM loc "/usr/lib64")
    list(REMOVE_ITEM loc "-L/usr/lib")
    list(REMOVE_ITEM loc "-L/usr/lib64")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib64")

    # items could themselves be lists, e.g. rpath=/usr/lib:/usr/local/lib
    foreach (item ${loc})
        set(item1 ${item})
        removeUnwantedCompileItemsFromColonString(item1)
        list(APPEND final_result ${item1})
    endforeach()

    set (${compileList} ${final_result} PARENT_SCOPE)
endfunction()


function(removeUnwantedCompileItemsFromString compileString)
    # convert from string to list, remove items, then convert back to string
    string (REPLACE " "  ";"   LOC_AS_LIST "${${compileString}}")
    removeUnwantedCompileItems(LOC_AS_LIST)
    string (REPLACE ";"  " "   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${compileString} " ${LOC_AS_STRING}" PARENT_SCOPE) # preserve leading space
endfunction()



##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro




# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
if( ECCODES_FOUND )
  string (REPLACE " eccodes"  " -leccodes"  GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
else()
  string (REPLACE " grib_api" " -lgrib_api" GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
endif()


set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed


# we may need to add the netCDF lib dir to the rpath. We don't seem to have a variable
# which tells us this directly, so we need to make an educated guess...
if(DEFINED NETCDF_INCLUDE_DIR)
    set(NETCDF_LIB_RPATH "-Wl,-rpath,${NETCDF_INCLUDE_DIR}/../lib64:${NETCDF_INCLUDE_DIR}/../lib")
    set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${NETCDF_LIB_RPATH}")
endif()

set(GRIB_API_LIBRARIES_STR_ORIGINAL "${GRIB_API_LIBRARIES_STR}")       # keep a backup for later


# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).

# first, if GRIB_API_PATH is not defined, then we need to compute the path
set( grib_handling_pkg grib_api )
if( ECCODES_FOUND )
  set( grib_handling_pkg eccodes )
endif()
if(NOT GRIB_API_PATH)
    get_property(GRIB_LIB_PATH TARGET ${grib_handling_pkg} PROPERTY LIBRARY_OUTPUT_DIRECTORY)
    if(GRIB_LIB_PATH)
        set(GRIB_API_PATH ${GRIB_LIB_PATH}/..)
    else()
        if (grib_api_BASE_DIR)
            set(GRIB_API_PATH ${grib_api_BASE_DIR})
        else()
            if(CMAKE_PREFIX_PATH)
                set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
            endif()
        endif()
    endif()
    ecbuild_info("Computed GRIB_PATH: ${GRIB_API_PATH}")
endif()


if(GRIB_API_PATH)
    set(GRIB_API_RPATH "${GRIB_API_PATH}/lib:${GRIB_API_PATH}/lib64")
endif()


# for each of the GRIB library's dependencies, we should find the directory name
# and add it to the -L and to the rpath

foreach (gtpl ${GRIB_API_TPL_LIBRARIES})
    get_filename_component(gtpl_i ${gtpl} PATH)  # DIRECTORY only in CMake > 2.8.12+
    list(APPEND GRIB_LIB_TPL_DIRS ${gtpl_i})
endforeach()

if (GRIB_LIB_TPL_DIRS)
    list(REMOVE_DUPLICATES GRIB_LIB_TPL_DIRS)
    string (REPLACE ";" ":"   GRIB_LIB_TPL_RPATH    "${GRIB_LIB_TPL_DIRS}")
endif()
set(GRIB_API_RPATH "${GRIB_API_RPATH}:${GRIB_LIB_TPL_RPATH}")

set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 -Wl,-rpath,${GRIB_API_RPATH} ${GRIB_API_LIBRARIES_STR}")
removeUnwantedCompileItemsFromString(GRIB_API_LIBRARIES_STR)


# add the GRIB include directories to the compiler directives

foreach (inc ${GRIB_API_INCLUDE_DIRS})
    set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
endforeach()


list(APPEND METVIEW_INLINE_DEFINITIONS ${GRIB_API_DEFINITIONS})


#
# something similar for libemos
#

if (TARGET emos)
    # find the actual path to the emoslib library
    get_property(EMOS_LIB_PATH TARGET emos PROPERTY LOCATION)
    list(REMOVE_ITEM EMOS_LIB_PATH "debug")     # remove non-compiler items from the string
    list(REMOVE_ITEM EMOS_LIB_PATH "optimized") # remove non-compiler items from the string
    string (REPLACE ";"         " "           EMOS_LIBRARIES_STR        "${EMOS_LIB_PATH}")

    if(LIBEMOS_PATH)
        set(EMOS_LIBRARIES_STR "-L${LIBEMOS_PATH}/lib -L${LIBEMOS_PATH}/lib64 -Wl,-rpath,${LIBEMOS_PATH}/lib:${LIBEMOS_PATH}/lib64 ${EMOS_LIBRARIES_STR}")
        # message(STATUS "${EMOS_LIBRARIES_STR}")
    endif()

    foreach (inc ${LIBEMOS_INCLUDE_DIRS})
        set(LIBEMOS_INCLUDE_DIRS_STR "${LIBEMOS_INCLUDE_DIRS_STR} -I${inc}")
    endforeach()

    list(APPEND METVIEW_INLINE_DEFINITIONS ${LIBEMOS_DEFINITIONS})

    set(LIBEMOS_TPL_LIBS_COPY " ${LIBEMOS_TPL_LIBRARIES}") # add a space to the beginning
    removeUnwantedCompileItems(LIBEMOS_TPL_LIBS_COPY)

    foreach(elib ${LIBEMOS_TPL_LIBS_COPY})
        get_filename_component(elibpath ${elib} PATH)
        if("${elibpath}" STREQUAL "")
            string(FIND ${elib} "-l" MINUS_L_POS)
            if(MINUS_L_POS EQUAL -1) # does not start with -l
                set(ELIB_TPL_STR "${ELIB_TPL_STR} -l${elib}")
            else()
                set(ELIB_TPL_STR "${ELIB_TPL_STR} ${elib}")
            endif()
        else()
            string(STRIP ${elibpath} ELIBPATH_STRIPPED)
            set(ELIB_TPL_STR "${ELIB_TPL_STR} -L${ELIBPATH_STRIPPED} -Wl,-rpath,${ELIBPATH_STRIPPED} ${elib}")
        endif()
    endforeach()

    removeUnwantedCompileItemsFromString(EMOS_LIBRARIES_STR)
    removeUnwantedCompileItemsFromString(ELIB_TPL_STR)
endif()

#
# something similar for fdb
#

if(FDB_FOUND)
    if(FDB_LIBRARY)  # fdb in bundle
        get_filename_component(FDB_LIB_DIR ${FDB_LIBRARY} PATH)
        set(FDB_LIBRARIES_STR "${FDB_LIBRARY} -Wl,-rpath,${FDB_LIB_DIR}")
    else()           # fdb not in bundle
        foreach(fdblib ${FDB_LIBRARIES})
            set(FDB_MINUS_L_LIBS " -l${fdblib} ${FDB_MINUS_L_LIBS}")
        endforeach()
        set(FDB_LIBRARIES_STR "")
        set(libdirs lib lib64)
        foreach(libdir ${libdirs})
            set(FDB_LIBRARIES_STR "-Wl,-rpath,${fdb_BASE_DIR}/${libdir} -L${fdb_BASE_DIR}/${libdir} ${FDB_LIBRARIES_STR}")
        endforeach()
        set(FDB_LIBRARIES_STR "${FDB_MINUS_L_LIBS} ${FDB_LIBRARIES_STR}")
    endif()
endif()


# in the case of a static libemos, we may need to be explicit about about the Fortran libraries when
# building inline C
foreach(fortlib ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
    set(IMPLICIT_FORTRAN_LIBS "-l${fortlib}  ${IMPLICIT_FORTRAN_LIBS}")
endforeach()



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)



# in the case of a bundle, the GRIB_API and emoslib locations will have been
# set to their build directories, which is correct when running from 
# the build directory, but not once installed, so we have to change these
# to the location where they will be installed, and create another 'compile'
# script which is the one that will actually be installed. In the case where
# we're not building a bundle, these two compile scripts will be identical.

# this checks if ECCODES is inside a bundle with us
if(DEFINED METVIEW_BUNDLE OR METVIEW_BUNDLE_TYPE STREQUAL "MMG")
    set(GRIB_API_LIBRARIES_STR    "-L${CMAKE_INSTALL_PREFIX}/lib ${GRIB_API_LIBRARIES_STR_ORIGINAL}")
    set(GRIB_API_INCLUDE_DIRS_STR "-I${CMAKE_INSTALL_PREFIX}/include")
    set(GRIB_API_PATH ${CMAKE_INSTALL_PREFIX})
endif()


# this checks if ECCODES is inside a bundle with us
if(DEFINED METVIEW_BUNDLE OR METVIEW_BUNDLE_TYPE STREQUAL "MM")
	string(REPLACE "${CMAKE_BINARY_DIR}/lib"  "${CMAKE_INSTALL_PREFIX}/lib"  EMOS_LIBRARIES_STR  "${EMOS_LIBRARIES_STR}")
endif()


# it would be nice to be a bit neater here, but this aspect is hard-coded in ecCodes
# and the fact that the path for MMFS definitions is in /MEMFS is not accessible
# from CMake, so we need to duplicate that piece of information here

if(ECCODES_HAVE_MEMFS)
    set(GRIB_API_SHARE_DIR "/MEMFS")
else()
    set(GRIB_API_SHARE_DIR "${GRIB_API_PATH}/share/${grib_handling_pkg}")
endif()



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile_install @ONLY)



install( FILES ${CMAKE_BINARY_DIR}/bin/compile_install  
         DESTINATION ${MV_BIN_DIR}
         RENAME      compile
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# CONFIG.site

if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()

if(DEFINED METVIEW_BUNDLE)
    set(METVIEW_BUNDLE_SRC ${CMAKE_SOURCE_DIR})
endif()

if(DEFINED METVIEW_BUNDLE_MAGICS)
    set(MV_BUNDLE_MAGICS_SRC ${CMAKE_SOURCE_DIR}/magics)
endif()



ecbuild_get_date(TODAYS_DATE)


# # Add certain paths to LD_LIBRARY_PATH.
# # If the given path is not a standard system one, then add it to our list
# # of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# # avoid adding system paths here because they can override non-default
# # paths (case in point: the wrong OpenGL library has been known to be
# # picked up - used by VAPOR).
#
# NO - this is not really needed with the rpath, and it can lead, in the
# case of a bundle, to the build directory (Magics) going into the
# LD_LIBRARY_PATH even when installed (no harmful effect seen though).
# 
# set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
# set(METVIEW_LD_PATHS "")
# 
# foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})
#     list(FIND SYS_LIBDIRS ${LIBPATH} IND)
#     if(IND EQUAL -1)  # path not in the list of system paths
#         set(METVIEW_LD_PATHS "${LIBPATH}:${METVIEW_LD_PATHS}")
#     endif()
# endforeach()



# MAGPLUS_HOME - under normal circumstances, we link with a specific

=== src/Desktop/CMakeLists.txt ===
set(desktop_qt_wrap_files                          
                         MvQAdvancedSearch.h
                         MvQBookmarks.h
                         MvQEditor.h
                         MvQFileBrowser.h
                         MvQDetailedFolderView.h
                         MvQIconMimeData.h
                         MvQColourGradLine.h
                         MvQColourListLine.h
                         MvQDrawerPanel.h
                         MvQEcLayerHelp.h
                         MvQEcLayerLine.h
                         MvQEcStyleHelp.h
                         MvQEcStyleLine.h
                         MvQPathWidget.h
                         Runnable.h
                         MvQFileWatcher.h
                         MvQFind.h
                         MvQFolderDrawerPanel.h
                         MvQFolderHistory.h
                         MvQFolderPanel.h
                         MvQFolderWidget.h
                         MvQFolderModel.h
                         MvQIconFolderView.h
                         MvQFolderViewDelegate.h
                         MvQFolderWatcher.h
                         #MvQHelpBrowser.h
                         MvQListFolderViewBase.h
                         MvQNewIconWidget.h
                         MvQRequestPanelLine.h
                         MvQBoolLine.h
                         MvQColourLine.h
                         MvQComboBoxLine.h
                         MvQIconHolder.h
                         MvQIconLine.h
                         MvQScrolledTextLine.h
                         MvQSearchPanel.h
                         MvQStringLine.h
                         MvQTextLine.h
                         MvQRequestPanelHelp.h
                         MvQColourHelp.h
                         MvQListHelp.h
                         MvQIconHelp.h
                         MvQLogDialog.h
                         MvQPageView.h
                         MvQPaletteHelp.h
                         MvQPaletteLine.h
                         MvQProductBrowser.h
                         MvQRequestPanelWidget.h
                         MvQScriptHelp.h
                         MvQSliderLine.h
                         MvQStationsHelp.h
                         MvQStyleHelp.h
                         MvQStyleLine.h
                         MvQStyleTreeWidget.h
                         MvQTemplateDrawer.h
                         MvQTemporaryEditor.h
                         #MvQTools.h
                         MvQViewDrawer.h
                         ComputeEditor.h
                         ViewEditor.h
                         SimpleEditor.h
                         FamilyEditor.h
                         MacroParamEditor.h
                         Tools.h
                         Input.h
 )

if(METVIEW_QT5)
  QT5_WRAP_CPP(Desktop_MOC 
       ${desktop_qt_wrap_files}
  )
  QT5_ADD_RESOURCES(Desktop_RES desktop.qrc)
else()
  QT4_WRAP_CPP(Desktop_MOC 
       ${desktop_qt_wrap_files}
  )
  QT4_ADD_RESOURCES(Desktop_RES desktop.qrc)
endif()

set(desktop_srcs    MvMainQtBrowser.cc
                    MvQ.cc
                    MvQActionList.cc
                    MvQAdvancedSearch.cc
                    MvQBookmarks.cc
                    MvQBoolLine.cc
                    MvQColourHelp.cc
                    MvQColourLine.cc
                    MvQColourGradLine.cc
                    MvQColourListLine.cc
                    MvQComboBoxLine.cc
                    MvQContextMenu.cc
                    MvQDesktop.cc
                    MvQDesktopSettings.cc
                    MvQDetailedFolderView.cc
                    MvQDrawerPanel.cc
                    MvQDrawerView.cc
                    MvQEcLayerDb.cc
                    MvQEcLayerHelp.cc
                    MvQEcLayerLine.cc
                    MvQEcStyleHelp.cc
                    MvQEcStyleLine.cc
                    MvQEditor.cc
                    MvQExternalHelp.cc
                    MvQFileBrowser.cc
                    MvQFileWatcher.cc
                    MvQFind.cc
                    MvQFolderDrawerPanel.cc
                    MvQFolderHistory.cc
                    MvQFolderItemProperty.cc
                    MvQFolderModel.cc
                    MvQFolderNavigation.cc
                    MvQFolderPanel.cc
                    MvQFolderViewBase.cc
                    MvQFolderViewDelegate.cc
                    MvQFolderViewHandler.cc
                    MvQFolderWatcher.cc
                    MvQFolderWidget.cc
                    MvQGeoHelp.cc
                    #MvQHelpBrowser.cc
                    MvQIconFolderView.cc
                    MvQIconHelp.cc
                    MvQIconHelpView.cc
                    MvQIconHolder.cc
                    MvQIconLine.cc
                    MvQIconMimeData.cc
                    MvQIconObjectModel.cc
                    MvQIconProvider.cc
                    MvQIconStripView.cc
                    MvQListHelp.cc
                    MvQListFolderViewBase.cc
                    MvQLogDialog.cc
                    MvQMessageBox.cc
                    MvQNewIconWidget.cc
                    MvQNoneLine.cc
                    MvQPageView.cc
                    MvQPalette.cc
                    MvQPaletteDb.cc
                    MvQPaletteHelp.cc
                    MvQPaletteLine.cc
                    MvQPathWidget.cc
                    MvQProductBrowser.cc
                    MvQRecentIcons.cc
                    MvQRequestPanelHelp.cc
                    MvQRequestPanelLine.cc
                    MvQRequestPanelWidget.cc
                    MvQScriptHelp.cc
                    MvQScrolledTextLine.cc
                    MvQSearchPanel.cc
                    MvQSliderLine.cc
                    MvQStationsHelp.cc
                    MvQStringLine.cc
                    MvQStyleDb.cc
                    MvQStyleHelp.cc
                    MvQStyleLine.cc
                    MvQStyleTreeWidget.cc
                    MvQTemplateDrawer.cc
                    MvQTemporaryEditor.cc
                    MvQTextLine.cc
                    MvQTheme.cc
                    #MvQTools.cc
                    MvQViewDrawer.cc
                    Action.cc
                    ActionCommand.cc
                    Command.cc
                    ComputeEditor.cc
                    ConfigLoader.cc
                    Counted.cc
                    Dependancy.cc
                    Drop.cc
                    Editor.cc 
                    EditorDrawerFactory.cc
                    EditorFactory.cc
                    EditTransaction.cc
                    FamilyEditor.cc
                    FamilyObject.cc
                    FamilyScanner.cc
                    FileObject.cc
                    Folder.cc
                    FolderDatabase.cc
                    FolderInfo.cc
                    FolderSearchData.cc
                    FolderSettings.cc
                    HelpFactory.cc
                    IconClass.cc 
                    IconFactory.cc
                    IconGroupTools.cc
                    IconInfo.cc
                    IconObject.cc
                    Input.cc
                    InternalService.cc
                    InternalTask.cc
                    Items.cc
                    Language.cc
                    LineFactory.cc
                    Log.cc
                    MacroGuiObject.cc
                    MacroObject.cc
                    MacroParamEditor.cc
                    MacroParamObject.cc
                    MacroParamState.cc
                    MessageObserver.cc
                    MethodCommand.cc
                    MetviewService.cc
                    MetviewTask.cc
                    NoEditor.cc
                    Parameter.cc
                    Product.cc
                    ProductFolder.cc
                    Protocol.cc
                    Queue.cc
                    RequestPanel.cc
                    RequestPanelItem.cc
                    ReplyObserver.cc
                    ResolveTransaction.cc
                    RootFolder.cc
                    Runnable.cc
                    ShellService.cc
                    ShellTask.cc
                    Service.cc
                    ServiceEditor.cc
                    SimpleEditor.cc
                    StandardObject.cc
                    State.cc
                    SystemFolder.cc
                    Task.cc
                    TeeBuffer.cc
                    TeeStream.cc
                    TemporaryEditor.cc
                    TemporaryFolder.cc
                    TemporaryObject.cc
                    Tools.cc
                    Transaction.cc
                    ViewEditor.cc
                    Wastebasket.cc)



ecbuild_add_executable( TARGET       Desktop
                        SOURCES      ${desktop_srcs}
                                     ${Desktop_MOC}
                                     ${Desktop_RES}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${METVIEW_QT_INCLUDE_DIRS}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS} ${GDBM_LIB}
                    )

=== src/Macro/CMakeLists.txt ===
# TODO: mvimportDesktop  perlaccess????


set(Macrolib_srcs
    value.cc code.cc variable.cc context.cc script.cc files.cc
    misc.cc number.cc stack.cc date.cc mstring.cc request.cc
    Unix.cc grib.cc mlist.cc module.cc remote.cc function.cc
    matrix.cc image.cc arith.cc extern.cc mvector.cc mtable.cc library.cc
    debug.cc bufr.cc compute.cc mgptset.cc vismod.cc macroy.c
    netcdf.cc object.cc pngjpeg.cc mflextra.cc python.cc
)


include_directories( include )  # relative to the current source directory


if( HAVE_PPROC_MIR )
    add_definitions( -DHAVE_PPROC_MIR )
    include_directories(${MIR_INCLUDE_DIRS})
endif()

if( HAVE_PPROC_EMOS )
    add_definitions( -DHAVE_PPROC_EMOS )
endif()

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
	COMMAND ${FLEX_EXECUTABLE} -l ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/macrol.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macrol.l)

ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
	COMMAND ${BISON_EXECUTABLE} -y ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/macroy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)

ADD_CUSTOM_TARGET(macrolex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/macroy.c ${CMAKE_CURRENT_BINARY_DIR}/macrol.c)



#set(Macro_libs ${STANDARD_METVIEW_LIBS_ODB} ${METVIEW_EXTRA_LIBRARIES})

if(ENABLE_ODB)
    list(APPEND Macrolib_srcs codb.cc)
    list(APPEND Macro_libs ${METVIEW_ODB_API_LIBRARIES})
endif()


ecbuild_append_to_rpath("../lib") # so that libMvMacro can find libMvUtil, etc
ecbuild_add_library( TARGET           MvMacro
					 TYPE             SHARED
					 SOURCES          ${Macrolib_srcs}
					 TEMPLATES        ${common_templates}
					 DEFINITIONS      ${METVIEW_EXTRA_DEFINITIONS}
					 PRIVATE_INCLUDES ${METVIEW_STANDARD_INCLUDES}
					 LIBS             ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
					)

set(link_libs MvMacro Metview MvMars)
if (HAVE_FORTRAN)
    list(APPEND link_libs macro_api_f90)
endif()

#target_link_libraries(link_libs)


#target_link_libraries(MvMacro
#	 ${Macro_libs} ${STANDARD_METVIEW_LIBS} ${METVIEW_EXTRA_LIBRARIES}
#	"-Wl,--whole-archive"
##    app models
##    "-Wl,--no-whole-archive"
#)
# GIVES THE FOLLOWING ERROR:
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVbN2v___log_finite':
#/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: multiple definition of `_ZGVbN2v___log_finite'
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS):/home/abuild/rpmbuild/BUILD/glibc-2.22/mathvec/../sysdeps/x86_64/fpu/svml_finite_alias.S:31: first defined here
#/usr/lib64/libmvec_nonshared.a(svml_finite_alias.oS): In function `_ZGVcN4v___log_finite':


ecbuild_add_executable( TARGET       macro
                        SOURCES      main.cc
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${link_libs} #MvMacro
                    )

#ecbuild_add_executable( TARGET       pytest
#						SOURCES      python.cc
#						DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#						LIBS         ${link_libs} MvMacro
#					)


ADD_DEPENDENCIES(macro macrolex)


######################################################################################

# PROBLEM getting CMake to accept the arguments to 'sed'. One possibility would be to
# put this into a separate script; another would be to simply put the beau.h file
# directly into the repository and skip the step of generating it.

#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#	COMMAND lex -l ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l\; sed -e s/yy/zz/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/beaul.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beaul.l)
#
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#	COMMAND yacc -t ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y\; sed -e s/yy/zz/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/beauy.c
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/macroy.y)
#
#set(BS \\)
##	COMMAND sed -e 's/\\(.*\\)/\\"\\1\\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#ADD_CUSTOM_COMMAND(
#    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#	COMMAND sed -e 's/${BS}(.*${BS})/${BS}\"${BS}1\",/' < ${CMAKE_CURRENT_SOURCE_DIR}/beau.ps > ${CMAKE_CURRENT_BINARY_DIR}/beau.h
#    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/beauy.y)
#
#
#ADD_CUSTOM_TARGET(beaulex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/beauy.c ${CMAKE_CURRENT_BINARY_DIR}/beaul.c ${CMAKE_CURRENT_BINARY_DIR}/beau.h)
#
#
#ecbuild_add_executable( TARGET       beautify
#                        SOURCES      beauy.y beautify.c 
#                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
#                        INCLUDES     ${METVIEW_STANDARD_INCLUDES} ${CMAKE_CURRENT_BINARY_DIR}
#                        LIBS         ${Macro_libs}
#                    )
#
#ADD_DEPENDENCIES(beautify beaulex)


######################################################################################


set(mvimport_srcs
    mvimport.c
)

ecbuild_add_executable( TARGET       mvimport
                        SOURCES      ${mvimport_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


######################################################################################


set(mvimportDesktop_srcs
    mvimportDesktop.c
)

ecbuild_add_executable( TARGET       mvimportDesktop
                        SOURCES      ${mvimportDesktop_srcs}
                        DEFINITIONS
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )

=== src/uPlot/CMakeLists.txt ===
set(common_srcs
    AnnotationView.cc AverageView.cc BufrDecoder.cc
    Canvas.cc CartesianView.cc CommonXSectView.cc
    CreateAction.cc CreateTypeAction.cc
    DataBuilder.cc DataObject.cc Device.cc
    DrawingPriority.cc DropAction.cc
    GenAppService.cc
    GeopointsDecoder.cc GraphicsEngine.cc MvGribDecoder.cc
    HovmoellerView.cc Location.cc
    MvLayer.cc MacroConverter.cc MacroVisitor.cc
    MagicsGraphicsEngine.cc MagicsTranslator.cc
    MagPlusService.cc MapView.cc MatchingCriteria.cc MatchingInfo.cc
    MvDecoder.cc MvIcon.cc MvIconDataBase.cc
    NewpageAction.cc
    ObjectInfo.cc ObjectList.cc OutputFormatAction.cc
    Page.cc PlotAction.cc PlotMod.cc PlotModAction.cc PlotModBuilder.cc
    PlotModService.cc PlotModTask.cc PlotModView.cc PlotPageBuilder.cc
    PmContext.cc PmIndividualProjection.cc PmGeneralProjection.cc PmProjection.cc
    Preferences.cc Presentable.cc
    Root.cc
    SatelliteProjection.cc SimpleDecoder.cc
    SkipAction.cc SubPage.cc SuperPage.cc
    Task.cc ThermoView.cc VertProfView.cc XDevice.cc XSectView.cc ZoomStacks.cc)

if(ENABLE_UI)


set(common_qt_srcs
    MvQCursorData.cc
    MvQCursorDataWidget.cc
    MvQContentsModel.cc
    MvQContentsWidget.cc
    MvQDataWidget.cc
    MvQLayerContentsIcon.cc
    MvQLayerDataWidget.cc
    MvQLayerMetaDataWidget.cc
    MvQLayerModel.cc
    MvQLayerSuperPage.cc
    MvQLayerViewLevel.cc
    MvQLayerWidget.cc
    MvQMagnifier.cc
    MvQPlaceMark.cc
    MvQPlaceMarkDialog.cc
    MvQPlaceMarkMimeData.cc
    MvQPlaceMarkWidget.cc
    MvQPlaceMarkModel.cc
    MvQPlotView.cc 
    MvQPointSelection.cc
    MvQProgressBarPanel.cc
    MvQProgressItem.cc
    MvQProgressManager.cc
    MvQStepModel.cc
    MvQStepWidget.cc
    MvQZoom.cc
    MvQAreaSelection.cc
    MvQLineSelection.cc
    MvQZoomStackWidget.cc
    ShareTargets.cc)


set(common_moc_files 
    MvQCursorData.h
    MvQCursorDataWidget.h
    #MvQContentsModel.h
    MvQContentsWidget.h
    MvQDataWidget.h
    MvQEcChartsDialog.h
    MvQLayerContentsIcon.h
    MvQLayerDataWidget.h
    MvQLayerMetaDataWidget.h
    MvQLayerModel.h
    MvQLayerSuperPage.h
    MvQLayerViewLevel.h
    MvQLayerWidget.h
    MvQMagnifier.h
    MvQPlaceMark.h
    MvQPlaceMarkDialog.h
    MvQPlaceMarkMimeData.h
    MvQPlaceMarkWidget.h
    MvQPlaceMarkModel.h
    MvQPlotView.h 
    MvQPointSelection.h 
    MvQProgressManager.h
    MvQStepModel.h
    MvQStepWidget.h
    MvQZoom.h
    MvQAreaSelection.h
    MvQLineSelection.h
    MvQZoomStackWidget.h
    ExportDialog.h
    ShareTargets.h
    uPlotBase.h
    uPlot.h
)


set(common_ui_srcs
    MagPlusInteractiveService.cc
    PlotModInteractive.cc
    ExportDialog.cc
    MvQEcChartsDialog.cc
    uPlotBase.cc
)


# The Qt MOC file needs to be generated with the Weather Room slot functions,
# so we need to add the define here
if(ENABLE_WEATHER_ROOM)
    set(WEATHER_ROOM_MOC_FLAGS -DMETVIEW_WEATHER_ROOM)
endif()

if(METVIEW_QT5)
  QT5_WRAP_CPP(common_MOC ${common_moc_files} OPTIONS ${WEATHER_ROOM_MOC_FLAGS})
  QT5_ADD_RESOURCES(common_RES uPlot.qrc)
else()
  QT4_WRAP_CPP(common_MOC ${common_moc_files} OPTIONS ${WEATHER_ROOM_MOC_FLAGS})
  QT4_ADD_RESOURCES(common_RES uPlot.qrc)
endif()



#-------- uPLOT ------------------------------------------------------------------

set(uPlot_srcs
    MvMain.cc
    ${common_srcs}
    ${common_MOC}
    ${common_RES}
    ${common_ui_srcs}
    ${common_qt_srcs}
    uPlot.cc uPlotApp.cc
#   uPlot.h uPlotApp.h
)


if(ENABLE_WEATHER_ROOM)
    if(METVIEW_QT5)
      QT5_WRAP_CPP(wr_MOC MvQWeatherRoomDialog.h)
    else()
      QT4_WRAP_CPP(wr_MOC MvQWeatherRoomDialog.h)
    endif()
    list(APPEND uPlot_srcs  MvQWeatherRoomDialog.cc ${wr_MOC})
    set(WEATHER_ROOM_FLAGS METVIEW_WEATHER_ROOM)
endif()

if(ENABLE_SHARE_PLOT)
#    list(APPEND uPlot_srcs ShareTargets.cc)
    set(SHARE_PLOT_FLAGS METVIEW_SHARE_PLOT)
endif()

if(ENABLE_SHARE_TO_GLOBE)
     set(SHARE_GLOBE_FLAGS "MV_SHARE_GLOBE_BUILD=1")
endif()

# we need to make sure that 
#set(CMAKE_INCLUDE_DIRECTORIES_BEFORE "ON")

#include_directories(BEFORE ${MAGICS_INCLUDE_DIRS})


# the ODB_API libararies are required in the case where Metview was built with ODB support,
# but Magics wasn't

ecbuild_add_executable( TARGET       uPlot
                        SOURCES      ${uPlot_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS} ${WEATHER_ROOM_FLAGS} ${SHARE_PLOT_FLAGS} ${SHARE_GLOBE_FLAGS}
#                        INCLUDES     /a /b /c
                        INCLUDES     ${MAGICS_INCLUDE_DIRS} ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS_ODB} MagPlus MagWrapper ${METVIEW_ODB_API_LIBRARIES}
                    )

ecbuild_debug("UPLOT CMAKE_INCLUDE_PATH: " ${CMAKE_INCLUDE_PATH})
###nodist_bin_uPlot_SOURCES = ${uPlot_COMMON_QT_SOURCES_nodist} ${uPlot_COMMON_UI_SOURCES_nodist} \
###                           uPlot.moc.cpp


endif()  # UI



set(uPlotManager_srcs
    uPlotManager.cc
    uPlotService.cc
    )
#uPlotManager.hpp uPlotService.hpp

ecbuild_add_executable( TARGET       uPlotManager
                        SOURCES      ${uPlotManager_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )


#-------- uPLOT Batch-----------------------------------------------------------------

set(uPlotBatch_srcs
    MvMainuPlotBatch.cc
    MagPlusBatchService.cc
    PlotModBatch.cc
    uPlotBatchApp.cc
    
    ${common_srcs}
)
 ###MagPlusBatchService.h PlotModBatch.h uPlotBatchApp.h

# we add the QT flags tothe compilation directives here because although this module should have
# no dependencies on Qt, it still uses Magics++, and if that has been built with Qt support, then
# we will need the flags in order to have a correct compilation. If Magics++ has been built without
# Qt, then these flags should be empty, so no harm done.

# the ODB_API libararies are required in the case where Metview was built with ODB support,
# but Magics wasn't

ecbuild_add_executable( TARGET       uPlotBatch
                        SOURCES      ${uPlotBatch_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS}  NOMETVIEW_QT
                        INCLUDES     ${MAGICS_INCLUDE_DIRS}  ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS_ODB} MagPlus MagWrapper ${METVIEW_ODB_API_LIBRARIES}
                    )

#-------- GeoTool ---------------------------------------------------------------

if(ENABLE_UI)

if(METVIEW_QT5)
  QT5_WRAP_CPP(geotool_MOC GeoTool.h)
  QT5_ADD_RESOURCES(geotool_RES geoSelect.qrc)
else()
  QT4_WRAP_CPP(geotool_MOC GeoTool.h)
  QT4_ADD_RESOURCES(geotool_RES geoSelect.qrc)
endif()


set(uPlotGeoTool_srcs
    MvMainGeoTool.cc
    GeoTool.cc
    ${common_srcs}
    ${common_MOC}
    ${geotool_MOC}
    ${common_RES}
    ${geotool_RES}
    ${common_ui_srcs}
    ${common_qt_srcs}
    uPlot.cc uPlotApp.cc
    uPlot.h uPlotApp.h
)


# the ODB_API libararies are required in the case where Metview was built with ODB support,
# but Magics wasn't

ecbuild_add_executable( TARGET       GeoTool
                        SOURCES      ${uPlotGeoTool_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS} ${MAGICS_DEFINITIONS}
                        INCLUDES     ${MAGICS_INCLUDE_DIRS}  ${METVIEW_QT_INCLUDE_DIRS} ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${METVIEW_QT_LIBRARIES} ${STANDARD_METVIEW_LIBS_ODB} MagPlus MagWrapper ${METVIEW_ODB_API_LIBRARIES}
                    )

set(GeoToolManager_srcs
    GeoToolManager.cc
    )
#GeoToolManager.h

ecbuild_add_executable( TARGET       GeoToolManager
                        SOURCES      ${GeoToolManager_srcs}
                        DEFINITIONS  ${METVIEW_EXTRA_DEFINITIONS}
                        INCLUDES     ${METVIEW_STANDARD_INCLUDES}
                        LIBS         ${STANDARD_METVIEW_LIBS}
                    )
endif()  # UI


# -------------------------------------------------------

metview_module_files(ETC_FILES ObjectSpec.OutputFormats)


ecbuild_dont_pack(FILES "MvQWeatherRoomDialog.cc;MvQWeatherRoomDialog.h" )

=== test/macros/CMakeLists.txt ===

# ------------------------------------------------------------------------
# MACRO metview_etc_files
# Ensures the files listed in ETC_FILES are copied to the build directory
# and that they will be installed at install time
# ------------------------------------------------------------------------


set (POST_INSTALL_TEST_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh)
set (MVRUN "${CMAKE_INSTALL_PREFIX}/bin/${METVIEW_SCRIPT}")


macro(metview_macro_test)
    set(options)
    set(single_value_args MACRO)
    set(multi_value_args RESOURCES MACRO_ARGS)
    cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}" ${_FIRST_ARG} ${ARGN} )


    ecbuild_add_test(TARGET      ${_PAR_MACRO}_dummy_target
                     COMMAND     ${FULL_STARTUP_SCRIPT_PATH}
                     TYPE        SCRIPT
                     ARGS        -b ${_PAR_MACRO} ${_PAR_MACRO_ARGS}
                     RESOURCES   ${_PAR_MACRO} ${_PAR_RESOURCES})


    # add to the post-install tests too
    string (REPLACE ";" " " MACRO_ARGS "${_PAR_MACRO_ARGS}")  # ';' -> ' '
    file(APPEND ${POST_INSTALL_TEST_SCRIPT} "${MVRUN} -b ${_PAR_MACRO} ${MACRO_ARGS}\n")

    set(all_tests "${all_tests}${_PAR_MACRO} ") # note the spacing
endmacro()



# write the start of the post-install test script
file(WRITE  ${POST_INSTALL_TEST_SCRIPT} "#!/bin/sh\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# Run the tests on the installed version of Metview\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# -------------------------------------------------\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "set -eax\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")



set(all_tests) # empty to start with



if(ENABLE_PLOTTING)
    metview_macro_test(MACRO     HelloWorld.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     layoutx3.mv
                       RESOURCES set_output.mv ../data/z500.grb)

    metview_macro_test(MACRO     plot_from_read_grib.mv
                       RESOURCES set_output.mv ../data/fc_data.grib)
endif()


metview_macro_test(MACRO     grib_dates.mv
                   RESOURCES  ../data/fc_data.grib
                              ../data/hindcast.grib
                              ../data/fc_long_step.grib
                              ../data/monthly_avg.grib)

metview_macro_test(MACRO     grib_keys.mv
                   RESOURCES  ../data/fc_data.grib)

metview_macro_test(MACRO     grib_nearest_gridpoint.mv
                   RESOURCES  ../data/t1000_LL_1x1.grb
                              ../data/t1000_LL_1x1_subarea.grb
                              ../data/t1000_LL_2x2.grb
                              ../data/t1000_LL_2x2_with_missing.grb
                              ../data/t1000_reg_gg_N48.grib
                              ../data/t1000_red_gg_N48.grib)

metview_macro_test(MACRO     interpolation_sh_to_ll.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_sh_to_rgg.mv
                   RESOURCES  ../data/t1000_SH.grb)

metview_macro_test(MACRO     interpolation_rgg_to_ll.mv
                   RESOURCES  ../data/t1000_SH_to_RGG_reference.grb)

metview_macro_test(MACRO     grib_to_gpt.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb)

metview_macro_test(MACRO     gpt_to_grib_core.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/gpt_to_grib_reciprocal_reference.grb
                              ../data/gpt_to_grib_exp_mean_reference.grb
                              ../data/gpt_to_grib_exp_sum_reference.grb)

metview_macro_test(MACRO     gpt_to_grib_with_template.mv
                   RESOURCES  ../data/t1000_LL_2x2.grb ../data/10U_GG.grb)

metview_macro_test(MACRO     gpt_to_grib_nearest.mv
                   RESOURCES  ../data/t1000_LL_7x7.grb
                              ../data/example_XYLDTZ.geo
                              ../data/gpt_to_grib_nearest_sum_reference.grb
                              ../data/gpt_to_grib_nearest_mean_reference.grb
                              ../data/gpt_to_grib_nearest_count_reference.grb
                              ../data/nearest_gridpoint_gpt_ref_1.gpt)

metview_macro_test(MACRO     geopoint_types.mv
                   RESOURCES  ../data/bufr_obs_filter_basic_reference.gpt
                              ../data/example_POLAR_VECTOR.geo
                              ../data/example_XYZ.geo
                              ../data/example_XY_VECTOR.geo)

metview_macro_test(MACRO     gpt_set.mv
                   RESOURCES  ../data/gpt_to_grib_input_1.gpt
                              ../data/bufr_picker_reference.gpt
                              ../data/bufr_obs_filter_area_reference.gpt
                              ../data/bufr_obs_filter_custom_reference.gpt
                              ../data/nearest_gridpoint_gpt_ref_1.gpt
                              ../data/t1000_LL_1x1.grb
                              ../data/hindcast.grib)

#metview_macro_test(MACRO     interpolation_gg_to_subarea.mv
#                   RESOURCES  ../data/10U_GG.grb)

metview_macro_test(MACRO     bufr_obs_filter.mv
                   RESOURCES  ../data/bufr-3.bufr
				           ../data/compress_3.bufr
				           ../data/bufr_obs_filter_basic_reference.gpt
							  ../data/temp_10.bufr
							  ../data/bufr_obs_filter_level_reference.gpt
							  ../data/synop_multi_subset_uncompressed.bufr
							  ../data/bufr_obs_filter_area_reference.gpt
							  ../data/amsua_13.bufr
							  ../data/bufr_obs_filter_time_reference.gpt
							  ../data/bufr_obs_filter_custom_reference.gpt
							  ../data/bufr_obs_filter_blockstation_reference.gpt
							  ../data/aircraft_10.bufr
							  ../data/bufr_obs_filter_subtype_reference.gpt)

metview_macro_test(MACRO     bufr_picker.mv
                   RESOURCES  ../data/bufr-2.bufr ../data/bufr_picker_reference.gpt
                              ../data/cape-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_compressed_reference.gpt
                              ../data/2t-ens.bufr ../data/bufr_picker_two_coordinate_descriptors_uncompressed_reference.gpt)

if(ENABLE_UI)
metview_macro_test(MACRO     bufr_filter.mv
                   RESOURCES  ../data/temp_small.bufr ../data/aircraft_small.bufr
                            ../data/ens_multi_subset_uncompressed.bufr
                            ../data/ens_multi_subset_compressed.bufr
                            ../data/synop_multi_subset_uncompressed.bufr
                            ../data/tropical_cyclone.bufr)
endif()

metview_macro_test(MACRO     inline_c.mv
                   RESOURCES ../data/z500.grb)

if(HAVE_FORTRAN)
metview_macro_test(MACRO     inline_fortran.mv
                   RESOURCES ../data/z500.grb)
endif()

metview_macro_test(MACRO     station.mv)

metview_macro_test(MACRO     vectors.mv
                   RESOURCES ../data/gpt_to_grib_nearest_sum_reference.grb
                             ../data/bufr_picker_reference.gpt)

metview_macro_test(MACRO     lists.mv)

metview_macro_test(MACRO     strings.mv)

metview_macro_test(MACRO     dates.mv)

metview_macro_test(MACRO     fieldsets.mv
                   RESOURCES ../data/hindcast.grib
                             ../data/tuv_pl.grib)

metview_macro_test(MACRO     llmatrix.mv
                   RESOURCES ../data/myllmat.llmat)


metview_macro_test(MACRO     geopoints.mv
                   RESOURCES ../data/geopoints_with_metadata.gpt
                             ../data/bufr_picker_reference.gpt)

metview_macro_test(MACRO     netcdf_computations.mv
                   RESOURCES ../data/xs_with_missing_vals.nc
                             ../data/xs_without_missing_vals.nc
                             ../data/nc_from_grib.nc
                             ../data/xs_date_mv5.nc)

#metview_macro_test(MACRO     "../../bin/mv_flextra_prep.mv 1 mv_flextra_prepare_test01.txt"
#                   RESOURCES  ../data/mv_flextra_prepare_test01.txt
#                              ../data/hindcast.grib)

metview_macro_test(MACRO     divrot.mv
                   RESOURCES ../data/vorticity_divergence_500_sh.grb)

metview_macro_test(MACRO     input_visualiser_missing_value.mv)

#metview_macro_test(MACRO      mv_flextra_prep.mv
#                   MACRO_ARGS 1 mv_flextra_prepare_test01.txt
#                   RESOURCES  ../../scripts/mv_flextra_prep.mv
#                              ../data/mv_flextra_prepare_test01.txt)

if(ENABLE_MARS)
    metview_macro_test(MACRO      MarsAccess.mv
                       RESOURCES  ../data/10U_GG.grb )
endif()


if(METVIEW_ODB)
    metview_macro_test(MACRO      odb_read.mv
                       RESOURCES  ../data/odb_test_set.odb )

    metview_macro_test(MACRO      odb_filter.mv
                       RESOURCES  ../data/odb_test_set.odb )

    if(ENABLE_PLOTTING)
        metview_macro_test(MACRO      odb_visualiser.mv
                           RESOURCES  ../data/odb_test_set.odb )
    endif()
endif()


# finish the post-install test script
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "# if we got this far, then all tests must have succeeded\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "echo \"ALL TESTS PASSED\"\n")
file(APPEND ${POST_INSTALL_TEST_SCRIPT} "echo \"\"\n")



# generate a script which can be used to run the tests on the installed version
set(METVIEW_COMMAND "${CMAKE_INSTALL_PREFIX}/bin/${METVIEW_SCRIPT}")
set(TESTS_DIR       "${CMAKE_CURRENT_BINARY_DIR}")

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/metview_post_install_tests.sh 
         DESTINATION ${MV_BIN_DIR}
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== share/metview/eccharts/CMakeLists.txt ===
if (ENABLE_UI)

    add_subdirectory(style_previews)

    set(files layers.json layers_mars.json styles.json)

    # at configure time we can just copy most of the files across to the build directory
    foreach( f ${files} )
        configure_file(${f} ${CMAKE_BINARY_DIR}/share/metview/eccharts/ COPYONLY)
    endforeach()

    foreach( f ${files} )

        # ensure file is installed at install time
        install( FILES ${CMAKE_BINARY_DIR}/share/metview/eccharts/${f}
                 DESTINATION share/metview/eccharts
                 PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
    endforeach()

    # install contour style preview images
    install(DIRECTORY "${CMAKE_BINARY_DIR}/share/metview/eccharts/style_previews"
            DESTINATION "share/metview/eccharts"
            PATTERN *.tar.gz EXCLUDE)

endif()

=== debian/changelog ===
metview (5.2.1-2) unstable; urgency=medium

  * Drop hard-coded gfortran-8; use gfortran 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Nov 2018 05:02:52 +0000

metview (5.2.1-1) unstable; urgency=medium

  * New upstream release
  * Move libmetview-dev include files to /usr/include/@MULTIARCH@

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Oct 2018 15:19:36 +0100

metview (5.2.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.2.1
  * Drop hard-coded xz compression

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Oct 2018 12:28:28 +0100

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 10), 
  gfortran, 
  flex, 
  bison, 
  libhdf5-dev, 
  libpango1.0-dev, 
  libfftw3-dev,
  chrpath, 
  mksh,
  libqt5webkit5-dev (>= 5.212.0~alpha2-15), 
  qtbase5-dev, libqt5xmlpatterns5-dev,
  libeccodes-dev (>= 2.2.0),
  libeccodes-tools,
  libodb-api-dev (>= 0.18.0-5),
  libemos-dev (>= 2:4.1.1-2),  libemos-bin,
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev, 
  libmagics++-dev (>= 2.34.3-3),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkg-config,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  cmake, 
  flextra, 
  libgeotiff-dev
Standards-Version: 4.2.1
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version})
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.
